package com.cretin.webdb.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.time.LocalDateTime;
import java.io.Serializable;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 定点抓取日志设备的列表
 * </p>
 *
 * @author Cretin
 * @since 2023-12-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class TbLogcatDeviceItem implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 打开状态  0 关闭 1 打开
     */
    private Integer openFlag;

    /**
     * 开机自动抓取日志开关 0 关闭 1 打开
     */
    private Integer autologFlag;

    /**
     * 当前日志状态  0 未启动 1 抓取中 2 已完成
     */
    private Integer currentStatus;

    /**
     * mac地址
     */
    private String mac;

    /**
     * 过滤字符串
     */
    private String logcatFilter;

    /**
     * 心跳间隔 单位秒 默认30秒
     */
    private Integer heartbeatInterval;

    private LocalDateTime addTime;

}
